// Создает объект Делегат для выполнения указанного метода объекта
//
// Параметры:
//   Объект - <Строка> - Программный объект, метод которого будет вызван
//   ИмяМетода - <Строка> - Имя метода (процедура/функция), который будет вызван
//   Параметры - <Произвольный> (необязательный) - Параметры для передачи в метод при его вызове
//		также параметры можно передать позже, через непосредственном вызове метода "Исполнить"
//
//  Возвращаемое значение:
//   <Делегат> - созданный объект Делега
//
Функция Создать(Объект, ИмяМетода, Параметры = Неопределено) Экспорт

	Делегат = Новый Делегат();
	Делегат.Конструктор(Объект, ИмяМетода, Параметры);

	Возврат Делегат;

КонецФункции

// Выполняет Делегат, т.е. вызываем соответствующий метод объекта с заданными параметрами
//
// Параметры:
//   Делегат - <Делегат> - Подготовленный для вызова делегат
//   НовыеПараметры - <Произвольный> (необязательный) - параметры для передачи в вызываемый метод
//		Если Неопределено, тогда используются параметры, указанные при создании Делегата
//
//  Возвращаемое значение:
//   <Произвольный> - возвращаемое значение вызываемого метода, если тот является функцией,
//		или Неопределено, если метод является процедурой
//
Функция Исполнить(Делегат, НовыеПараметры = Неопределено) Экспорт

	Возврат Делегат.Исполнить(НовыеПараметры);

КонецФункции
